`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/21/2020 02:35:20 PM
// Design Name: 
// Module Name: Lab3_1
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


`define FREQ_DIV_BIT 27
module frq_div_clk(
f_out, // divided clock output
ssd_clk,
f_crystal, // global clock input
rst // active low reset
);
output f_out; // divided output
input f_crystal; // global clock input
input rst; // active low reset
output reg [1:0]ssd_clk;
reg f_out; // clk output (in always block)
reg [`FREQ_DIV_BIT-1:0] ctl; // control signal to check if it's counted tp 50M
reg [`FREQ_DIV_BIT-1:0] cnt_tmp; 
reg [`FREQ_DIV_BIT-1:0] tmp1;
reg [`FREQ_DIV_BIT-1:0] tmp2; 
reg [1:0] clk_ctl;
reg [14:0]cnt_l;
reg [9:0]cnt_h;

always @*
{cnt_h, clk_ctl, cnt_l} = ctl;
// Combinational logics: increment, neglecting overflow
always @*
cnt_tmp = ctl + 1'b1;

always @*
   if(ctl == 50'd50_000_000)
       begin
           tmp2 = ~f_out;
           tmp1 = 27'd0;
       end
   else
      begin
           tmp2 = f_out; 
           tmp1 = cnt_tmp;
           ssd_clk = clk_ctl;
      end     
// Sequential logics: Flip flops
always @(posedge f_crystal or posedge rst)
if (rst) 
    begin
        ctl <= 27'd0;
        f_out <= 0;
    end
else 
    begin
        ctl <=  tmp1;
        f_out <= tmp2;
    end
endmodule
    
